my %track;
my %queuechan;
my %membername;
my %callunique;
my %connectqueue;
my %ishold;

$AMI_Event_Handler{'holdreport'}{'HOLD'} = sub {
    my $event = shift;
    my @allreturn;

    #my @keys =  keys %$event;
    #foreach my $key (@keys) {
    #    print "$key = ".${$event}{$key}."\n";
    #}
    #print "\n";

    my $status       = ${$event}{'Status'};  # On or Off
    my $channel      = ${$event}{'Channel'};
    my $uniq         = ${$event}{'Uniqueid'};

    #print "Hold $status chan $channel uniq $uniq\n";

    my $canal = FOP2::utils::get_channel(${$event}{'Channel'});
    my $event = "PAUSE";

    if(defined($queuechan{$canal})) {

        if($status eq "On") {
          $event ="PAUSE";
          $ishold{$canal}=1;
        } else {
          $event ="UNPAUSE";
          $ishold{$canal}=0;
        }

        my $name = $membername{$queuechan{$canal}};
        my $uniq = $callunique{$queuechan{$canal}};
        my $queue = $connectqueue{$queuechan{$canal}};

        my $linea = time()."|".$uniq."|".$queue."|".$name."|$event|Hold\n";
        open(my $fh, '>>', '/var/log/asterisk/queue_log') or warn "Could not open queue_log file $!";
        print $fh $linea;
        close $fh;

    }
    return @allreturn;

};

$AMI_Event_Handler{'holdreport'}{'AGENTCALLED'} = sub {
    my $event = shift;
    my @allreturn;
    #my @keys =  keys %$event;
    #foreach my $key (@keys) {
    #    print "$key = ".${$event}{$key}."\n";
    #}
    #print "\n";

    if ( ${$event}{'DestinationChannel'} =~ /^Local/ ) {
        # Track local agents to find real channel in DIAL event below 
        my $canal = FOP2::utils::get_channel(${$event}{'DestinationChannel'});
        $track{$canal}=1; 
    }
};

$AMI_Event_Handler{'holdreport'}{'DIAL'} = sub {
    my $event = shift;
    my @allreturn;
    #my @keys =  keys %$event;
    #foreach my $key (@keys) {
    #    print "$key = ".${$event}{$key}."\n";
    #}
    #print "\n";
    if(${$event}{'SubEvent'} eq "Begin") {
        my $canal = FOP2::utils::get_channel(${$event}{'Channel'});
        if(defined($track{$canal})) {
            my $desti = FOP2::utils::get_channel(${$event}{'Destination'});
            $queuechan{$desti}=$canal;
        }
    }
};

$AMI_Event_Handler{'holdreport'}{'AGENTCONNECT'} = sub {
    my $event = shift;
    my @allreturn;
    #my @keys =  keys %$event;
    #foreach my $key (@keys) {
    #    print "$key = ".${$event}{$key}."\n";
    #}
    #print "\n";
    my $canal = FOP2::utils::get_channel(${$event}{'Channel'});
    $membername{$canal} = ${$event}{'MemberName'};
    $callunique{$canal} = ${$event}{'Uniqueid'};
    $connectqueue{$canal} = ${$event}{'Queue'};
    if(!defined($queuechan{$canal})) { $queuechan{$canal}=$canal; }
};

$AMI_Event_Handler{'holdreport'}{'HANGUP'} = sub {
    my $event = shift;
    my @allreturn;
    #my @keys =  keys %$event;
    #foreach my $key (@keys) {
    #    print "$key = ".${$event}{$key}."\n";
    #}
    #print "\n";
    my $canal = FOP2::utils::get_channel(${$event}{'Channel'});
    if(defined($ishold{$canal})) {
        if($ishold{$canal}==1) {
            my $name = $membername{$queuechan{$canal}};
            my $uniq = $callunique{$queuechan{$canal}};
            my $queue = $connectqueue{$queuechan{$canal}};

            my $linea = time()."|".$uniq."|".$queue."|".$name."|UNPAUSE|Hold\n";
            open(my $fh, '>>', '/var/log/asterisk/queue_log') or warn "Could not open queue_log file $!";
            print $fh $linea;
            close $fh;
        }
    }
    delete $track{$canal};
    delete $queuechan{$canal};
    delete $membername{$canal};
    delete $callunique{$canal};
    delete $connectqueue{$canal};
    delete $ishold{$canal};
    return @allreturn;
};
